/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.thoughtworks.xstream.XStream
 *  com.thoughtworks.xstream.io.HierarchicalStreamDriver
 *  com.thoughtworks.xstream.io.xml.DomDriver
 *  fire.pb.scene.config.NpcDesc
 */
package fire.pb.scene;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.HierarchicalStreamDriver;
import com.thoughtworks.xstream.io.xml.DomDriver;
import fire.pb.scene.BlockInfo;
import fire.pb.scene.MonsterInfo;
import fire.pb.scene.config.NpcDesc;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.List;

public final class MapInfo {
    final int mapID;
    private BlockInfo blockInfo = null;
    private MonsterInfo monsterInfo = null;
    private List<NpcDesc> confNpcList = null;

    MapInfo(int mapid) {
        this.mapID = mapid;
        this.blockInfo = new BlockInfo(this.mapID);
    }

    int getMapID() {
        return this.mapID;
    }

    public BlockInfo getBlockInfo() {
        return this.blockInfo;
    }

    public MonsterInfo getMonsterInfo() {
        return this.monsterInfo;
    }

    List<NpcDesc> getConfNpcList() {
        return this.confNpcList;
    }

    public boolean existMazeFile() {
        return this.blockInfo.existMazeFile();
    }

    void load() {
        this.blockInfo.loadMap();
        this.blockInfo.loadChannels();
        this.blockInfo.genNoneBlockList();
        this.blockInfo.loadArea();
        this.blockInfo.genToufangPosList();
        this.monsterInfo = new MonsterInfo(this.getMapID());
        this.monsterInfo.load();
        this.loadNpcConfig();
    }

    private void loadNpcConfig() {
        String loadFile = "gamedata/map/" + this.mapID + "/npc.dat";
        XStream s = new XStream((HierarchicalStreamDriver)new DomDriver());
        s.alias("data", List.class);
        s.alias("record", NpcDesc.class);
        s.useAttributeFor(NpcDesc.class, "id");
        s.useAttributeFor(NpcDesc.class, "posx");
        s.useAttributeFor(NpcDesc.class, "posy");
        s.useAttributeFor(NpcDesc.class, "dir");
        try {
            this.confNpcList = (List)s.fromXML((InputStream)new FileInputStream(loadFile));
        }
        catch (FileNotFoundException fileNotFoundException) {
            // empty catch block
        }
    }
}

